package examples.xml;


import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import examples.beans.Employee;

public class SAXParserExample extends DefaultHandler{

	private List myEmpls;
	
	private String tempVal;
	
	
	private Employee tempEmp;
	
	
	public SAXParserExample(){
		myEmpls = new ArrayList();
	}
	
	public void runExample() {
		parseDocument();
		printData();
	}

	private void parseDocument() {
		
		//factory lekerese
		SAXParserFactory spf = SAXParserFactory.newInstance();
		try {
		
			//SAX parser insancia lekerese
			SAXParser sp = spf.newSAXParser();
			
			//feldolgozzuk (parse) az allomanyt, illetve regisztraljuk az aktualis osztalyt a call back metodusok szamara
			sp.parse("resource/employees.xml", this);
			
		}catch(SAXException se) {
			se.printStackTrace();
		}catch(ParserConfigurationException pce) {
			pce.printStackTrace();
		}catch (IOException ie) {
			ie.printStackTrace();
		}
	}

	/**
	 * vegigjarja a listat es kiirja az eredmenyt
	 */
	private void printData(){
		
		System.out.println("No of Employees '" + myEmpls.size() + "'.");
		
		Iterator it = myEmpls.iterator();
		while(it.hasNext()) {
			System.out.println(it.next().toString());
		}
	}
	

	//Esemenykezelok (Event Handlers)
	public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
		
		tempVal = "";
		if(qName.equalsIgnoreCase("Employee")) {
			//uj employee objektum letrehozasa
			tempEmp = new Employee();
			tempEmp.setType(attributes.getValue("type"));
		}
	}
	

	public void characters(char[] ch, int start, int length) throws SAXException {
		tempVal = new String(ch,start,length);
	}
	
	public void endElement(String uri, String localName, String qName) throws SAXException {

		if(qName.equalsIgnoreCase("Employee")) {
			//hozzaadjuk a listahoz az ujabb elemet
			myEmpls.add(tempEmp);
			
		}else if (qName.equalsIgnoreCase("Name")) {
			tempEmp.setName(tempVal);
		}else if (qName.equalsIgnoreCase("Id")) {
			tempEmp.setId(Integer.parseInt(tempVal));
		}else if (qName.equalsIgnoreCase("Age")) {
			tempEmp.setAge(Integer.parseInt(tempVal));
		}
		
	}
	
	public static void main(String[] args){
		SAXParserExample spe = new SAXParserExample();
		spe.runExample();
	}
	
}




