package examples.xml;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;




public class SimpleTransformXSLTServlet extends HttpServlet {
  
  
	private static final long serialVersionUID = 1L;
	public final static String FS = System.getProperty("file.separator"); 


  public void doGet (HttpServletRequest request,
                     HttpServletResponse response)
    throws ServletException, IOException
  {
    // content type beallitasa
    response.setContentType("text/html; charset=UTF-8");    
    // a kimenet a valasz PrintWriter-ebe kerul.
    PrintWriter out = response.getWriter();
    try
    {	
      TransformerFactory tFactory = 
                TransformerFactory.newInstance();
      //eleresi ut (real path) felepitese az xml es xsl allomanyokhoz valo hozzafereshez.
      String ctx = getServletContext().getRealPath("") + FS;        
      // megnyitjuk a XML illetve XSL allomanyokat
      //Mindketto a Web-alkalmazas gyokereben

      Source xmlSource = 
                new StreamSource
                             (new URL("file", "", ctx+"cdcatalog.xml").openStream());
      Source xslSource = 
                new StreamSource
                             (new URL("file", "", ctx+"cdcatalog.xsl").openStream());
      // generaljuk az atalakitast vegzo transformer-t.
      Transformer transformer = 
                             tFactory.newTransformer(xslSource);
      // elvegezzuk a transformaciot, a kimenetet pedig a valasz objektumnak kuldjuk
      transformer.transform(xmlSource, 
                           new StreamResult(out));
    }

    catch (Exception e)
    {
      out.write(e.getMessage());
      e.printStackTrace(out);    
    }
    // PrintWriter bezarasa
    out.close();
  }  
}
