package examples.xml;

import java.io.File;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 * JAXP 1.1 egyszeru demo
 */
public class SimpleXSLTTransform {

	/**
	 * Ket parametert kell megadni a parancssorban: egy XML allomany nevet, es
	 * egy XSLT allomany nevet. A transformacio eredmenye a standard kimenetre
	 * lesz irva
	 */
	public static void main(String[] args)
			throws TransformerException {
		if (args.length != 2) {
			System.err.println("Usage:");
			System.err.println("  java " + SimpleXSLTTransform.class.getName()
					+ " xmlFileName xsltFileName");
			System.exit(1);
		}

		File xmlFile = new File(args[0]);
		File xsltFile = new File(args[1]);

		Source xmlSource = new StreamSource(xmlFile);
		Source xsltSource = new StreamSource(xsltFile);
		Result result = new StreamResult(System.out);

		// TransformerFactory peldanyt hozunk letre
		TransformerFactory transFact = TransformerFactory.newInstance();

		Transformer trans = transFact.newTransformer(xsltSource);

		trans.transform(xmlSource, result);
	}
}
